Subject: Fwd: Re: [PATCH v3 14/15] gnu: chez-and-racket-bootstrap: Add 'chez-scheme-for-system'.

From: Philip McGrath <[email-masked]>
Date: Sat, 19 Feb 2022 17:34:30 -0500

(sorry, missed "reply all" ...)

----------  Forwarded Message  ----------

Subject: Re: [PATCH v3 14/15] gnu: chez-and-racket-bootstrap: Add 'chez-
scheme-for-system'.
Date: Saturday, February 19, 2022, 5:29:05 PM EST
From: Philip McGrath <[email-masked]>
To: Liliana Marie Prikler <[email-masked]>

Hi,

On Saturday, February 19, 2022 3:00:37 PM EST you wrote:
> Am Samstag, dem 19.02.2022 um 01:42 -0500 schrieb Philip McGrath:
> > +(define* (chez-scheme-for-system #:optional
> > +                                 (system (or (%current-target-
> > system)
> > +                                             (%current-system))))
> > +  "Return 'chez-scheme' unless only 'chez-scheme-for-racket'
> > supports SYSTEM,
> > +including support for native threads."
> > +  (if (and (nix-system->chez-machine system)
> > +           (not (and=> (chez-upstream-features-for-system system)
> > +                       (cut memq 'threads <>))))
> > +      chez-scheme-for-racket
> > +      chez-scheme))
> 
> Given your previous explanation this series looks clean enough so far,
> but this looks like a bug.  You probably want
> (if (and (nix-system->chez-machine system)
>     (and=> (chez-upstream-features-for-system system)
>            (cut memq 'threads <>)))
>     chez-scheme
>     chez-scheme-for-racket)
> This variant would in particular use chez-scheme-for-racket if nix-
> system->chez-machine returns #f.
> 
> I can make that adjustment for you assuming I interpreted this
> correctly.

Thanks for catching this! I must have gotten myself confused while changing to 
chez-upstream-features-for-system from the chez-machine->upstream-restriction 
version.

-Philip

-----------------------------------------